#include "../csc321.h"
#include "Shape.h"
//#include "Point3.h"
//#include "Vector3.h"

Shape::~Shape() {
}

void Shape::draw() {
	glBegin(GL_TRIANGLES);
	for (int i=0; i < vertices.size(); i +=3) {
		glNormal3dv(&normals[i][0]);
		glVertex3dv(&vertices[i][0]);
		glNormal3dv(&normals[i+1][0]);
		glVertex3dv(&vertices[i+1][0]);
		glNormal3dv(&normals[i+2][0]);
		glVertex3dv(&vertices[i+2][0]);
	}
	glEnd();
}

Shape::Shape() : vertices(), normals() {
}

void Shape::addTriangle(const Point3& p1, const Point3& p2, const Point3& p3,
					 const Vector3& n1, const Vector3& n2, const Vector3& n3) {
						 vertices.push_back(p1);
						 vertices.push_back(p2);
						 vertices.push_back(p3);
						 normals.push_back(n1);
						 normals.push_back(n2);
						 normals.push_back(n3);
}

Cylinder::Cylinder(int n, int m) : Shape() {
	double ca = 0.5;
	double sa = 0.0;
	for (int i = 1; i <= n; i++) {
		double a = (2 * M_PI * i) / n;
		double ca1 = 0.5 * cos(a);
		double sa1 = 0.5 * sin(a);
		
		addTriangle(Point3(0.0, 0.5, 0.0), Point3(ca1, 0.5, sa1), Point3(ca, 0.5, sa), 
			        Vector3(0.0, 1.0, 0.0), Vector3(0.0, 1.0, 0.0), Vector3(0.0, 1.0, 0.0));
		addTriangle(Point3(0.0, -0.5, 0.0), Point3(ca, -0.5, sa), Point3(ca1, -0.5, sa1), 
			        Vector3(0.0, -1.0, 0.0), Vector3(0.0, -1.0, 0.0), Vector3(0.0, -1.0, 0.0));

		ca = ca1;
		sa = sa1;
	}
}